

VERSION = "0.03"
AUTHOR = "martblek (martblek@gmail.com)"

vb = renoise.ViewBuilder()
dialog = nil
rns = nil
rnt = renoise.tool()
ra = renoise.app()

function convert_path(path)
  return string.gsub(path, "/", "D_E_E_P")
end

function revert_path(path)
  return string.gsub(path, "D_E_E_P", "/")
end

ReSpeak = renoise.Document.create("ReSpeak"){
  word_gap=3,
  kapitals=10,
  pitch=50,
  amplitude=100,
  speed=175,
  language=1,
  voice=1,
  text="Hello,I am ReSpeak",
  executable=convert_path("espeak"),
  clear_all_samples=true,
}

LANGUAGES = {{"Afrikaans","af"},
          {"Amharic","am"},
          {"Aragonese","an"},
          {"Arabic","ar"},
          {"Assamese","as"},
          {"Azerbaijani","az"},
          {"Bashkir","ba"},
          {"Belarusian","be"},
          {"Bulgarian","bg"},               
          {"Bengali","bn"},               
          {"Bishnupriya_Manipuri","bpy"},              
          {"Bosnian","bs"},               
          {"Catalan","ca"},               
          {"Cherokee","chr"},              
          {"Chinese_(Mandarin,_latin_as_English)","cmn"},
          {"Chinese_(Mandarin,_latin_as_Pinyin)","cmn-Latn-pinyin"},
          {"Czech","cs"},              
          {"Chuvash","cv"},               
          {"Welsh","cy"},               
          {"Danish","da"},               
          {"German","de"},               
          {"Greek","el"},              
          {"English_(Caribbean)","en-029"},
          {"English_(Great_Britain)","en"},
          {"English_(Scotland)","en-GB-scotland"},
          {"English_(Lancaster)","en-GB-x-gbclan"},
          {"English_(West_Midlands)","en-GB-x-gbcwmd"},
          {"English_(Received_Pronunciation)","en-GB-x-rp"},
          {"English_(America)","en-US"},
          {"English_(America,_New_York_City)","en-US-nyc"},        
          {"Esperanto","eo"},               
          {"Spanish_(Spain)","es"},               
          {"Spanish_(Latin_America)","es-419"},
          {"Estonian","et"},               
          {"Basque","eu"},                   
          {"Persian","fa"},               
          {"Persian_(Pinglish)","fa-Latn"},          
          {"Finnish","fi"},               
          {"French_(Belgium)","fr-BE"},
          {"French_(Switzerland)","fr-CH"},
          {"French_(France)","fr"},
          {"Gaelic_(Irish)","ga"},               
          {"Gaelic_(Scottish)","gd"},               
          {"Guarani","gn"},             
          {"Greek_(Ancient)","grc"},              
          {"Gujarati","gu"},
          {"Hakka_Chinese","hak"},              
          {"Hawaiian","haw"},        
          {"Hebrew","he"},            
          {"Hindi","hi"},             
          {"Croatian","hr"},         
          {"Haitian_Creole","ht"},               
          {"Hungarian","hu"},               
          {"Armenian_(East_Armenia)","hy"},
          {"Armenian_(West_Armenia)","hyw"},
          {"Interlingua","ia"},               
          {"Indonesian","id"},               
          {"Ido","io"},        
          {"Icelandic","is"},              
          {"Italian","it"},            
          {"Japanese","ja"},               
          {"Lojban","jbo"},              
          {"Georgian","ka"},               
          {"Kazakh","kk"},               
          {"Greenlandic","kl"},               
          {"Kannada","kn"},               
          {"Korean","ko"},                   
          {"Konkani","kok"},              
          {"Kurdish","ku"},               
          {"Kyrgyz","ky"},               
          {"Latin","la"},               
          {"Luxembourgish","lb"},               
          {"Lingua_Franca_Nova","lfn"},              
          {"Lithuanian","lt"},               
          {"Latgalian","ltg"},              
          {"Latvian","lv"},               
          {"Māori","mi"},               
          {"Macedonian","mk"},               
          {"Malayalam","ml"},               
          {"Marathi","mr"},               
          {"Malay","ms"},               
          {"Maltese","mt"},               
          {"Myanmar_(Burmese)","my"},               
          {"Norwegian_Bokmål","nb"},    
          {"Nahuatl_(Classical)","nci"},              
          {"Nepali","ne"},               
          {"Dutch","nl"},               
          {"Nogai","nog"},              
          {"Oromo","om"},               
          {"Oriya","or"},               
          {"Punjabi","pa"},               
          {"Papiamento","pap"},              
          {"Klingon","piqd"},             
          {"Polish","pl"},               
          {"Portuguese_(Portugal)","pt"},
          {"Portuguese_(Brazil)","pt-BR"},
          {"Pyash","py"},               
          {"Lang_Belta","qdb"},              
          {"Quechua","qu"},                   
          {"K'iche'","quc"},              
          {"Quenya","qya"},              
          {"Romanian","ro"},               
          {"Russian","ru"},               
          {"Russian_(Latvia)","ru-LV"},            
          {"Sindhi","sd"},               
          {"Shan_(Tai_Yai)","shn"},              
          {"Sinhala","si"},               
          {"Sindarin","sjn"},              
          {"Slovak","sk"},               
          {"Slovenian","sl"},               
          {"Lule_Saami","smj"},              
          {"Albanian","sq"},               
          {"Serbian","sr"},               
          {"Swedish","sv"},               
          {"Swahili","sw"},               
          {"Tamil","ta"},               
          {"Telugu","te"},               
          {"Thai","th"},               
          {"Turkmen","tk"},               
          {"Setswana","tn"},               
          {"Turkish","tr"},               
          {"Tatar","tt"},               
          {"Uyghur","ug"},               
          {"Ukrainian","uk"},               
          {"Urdu","ur"},               
          {"Uzbek","uz"},               
          {"Vietnamese_(Northern)","vi"},               
          {"Vietnamese_(Central)","vi-VN-x-central"},  
          {"Vietnamese_(Southern)","vi-VN-x-south"},    
          {"Chinese_(Cantonese)","yue"},
          {"Chinese_(Cantonese,_latin_as_Jyutping)","yue-Latn-jyutping"},
        }

VOICES = {"None", "adam", "Alex", "Alicia", "Andrea", "Andy", "anika", "anikaRobot",
          "Annie", "announcer", "antonio", "AnxiousAndy", "aunty", "belinda", "benjamin",
          "boris", "caleb", "croak", "david", "Demonic", "Denis", "Diogo", "ed", "edward",
          "edward2", "f1", "f2", "f3", "f4", "f5", "fast", "Gene", "Gene2", "grandma", "grandpa",
          "gustave", "Henrique", "Hugo", "iven", "iven2", "iven3", "iven4", "Jacky", "john",
          "kaukovalta", "klatt", "klatt2", "klatt3", "klatt4", "klatt5", "klatt6", "Lee", "linda",
          "m1", "m2", "m3", "m4", "m5", "m6", "m7", "m8", "marcelo", "Marco", "Mario", "max", "miguel",
          "Michael", "michel", "Mike", "Mr serious", "Nguyen", "norbert", "pablo", "paul", "pedro",
          "quincy", "RicishayMax", "RicishayMax2", "RicishayMax3", "rob", "robert", "robosoft",
          "sandro", "shelby", "steph", "Storm", "travis", "Tweaky", "victor", "whisper", "whisperf",
          "zac"}

LANGUAGE_NAMES = {}
LANGUAGE_SHORTS = {}

for _, langs in pairs(LANGUAGES) do
    table.insert(LANGUAGE_NAMES, langs[1])
    table.insert(LANGUAGE_SHORTS, langs[2])
end


renoise.tool():add_menu_entry{name="Sample Editor:ReSpeak TTS",invoke=function() prepare_for_start() end}
renoise.tool():add_menu_entry{name="Main Menu:Tools:Martblek:ReSpeak TTS",invoke=function() prepare_for_start() end}
renoise.tool():add_keybinding{name="Global:Tools:ReSpeak TTS",invoke=function() prepare_for_start() end}

_AUTO_RELOAD_DEBUG = function()
end

function file_exists(path)
  local f = io.open(path, "r")
  return f ~= nil and io.close(f)
end

page1 = vb:column{
  id="page1",
  margin = renoise.ViewBuilder.DEFAULT_CONTROL_MARGIN,
  spacing = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING,
  height = renoise.ViewBuilder.DEFAULT_CONTROL_HEIGHT,
  width=235,
  vb:column{
    margin = renoise.ViewBuilder.DEFAULT_CONTROL_MARGIN,
    spacing = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING,
    height = renoise.ViewBuilder.DEFAULT_CONTROL_HEIGHT,
    style="group",
    vb:multiline_textfield{
      id="text",
      width=220,
      height=100,
      style="border",
      text=ReSpeak.text.value,
    },
    vb:row{
      vb:text{text="Language:", width=100},
      vb:popup{
        id="language",
        width=120,
        items=LANGUAGE_NAMES,
        value=ReSpeak.language.value,
        notifier=function(voice)
          ReSpeak.language.value = voice
        end
      },
    },
    vb:row{
      vb:text{text="Voice:", width=100},
      vb:popup{
        id="voice",
        width=120,
        items=VOICES,
        value=ReSpeak.voice.value,
        notifier=function(voice)
          ReSpeak.voice.value = voice
        end
      },
    },
    vb:row{
      vb:text{width=100, text="Word gap: "},
      vb:valuebox{
        id="gap_box",
        width=120,
        min=1,
        max=10000,
        value=ReSpeak.word_gap.value,
        steps={10, 100},
        notifier = function(gap)
          ReSpeak.word_gap.value = gap
        end
      },
    },
    vb:row{
      vb:text{width=100, text="Pitch Kapitals: "},
      vb:valuebox{
        id="kapitals_box",
        width=120,
        min=1,
        max=100,
        value=ReSpeak.kapitals.value,
        steps={1, 5},
        notifier = function(kapitals)
          ReSpeak.kapitals.value = kapitals
        end
      },
    },
    vb:row{
      vb:text{width=100, text="Pitch: "},
      vb:valuebox{
        id="pitch_box",
        width=120,
        min=0,
        max=99,
        value=ReSpeak.pitch.value,
        steps={1, 5},
        notifier = function(pitch)
          ReSpeak.pitch.value = pitch
        end
      },
    },
    vb:row{
      vb:text{width=100, text="Amplitude: "},
      vb:valuebox{
        id="amplitude_box",
        width=120,
        min=0,
        max=200,
        value=ReSpeak.amplitude.value,
        steps={1, 5},
        notifier = function(amplitude)
          ReSpeak.amplitude.value = amplitude
        end
      },
    },
    vb:row{
      vb:text{width=100, text="Speed: "},
      vb:valuebox{
        id="speed_box",
        width=120,
        min=1,
        max=500,
        value=ReSpeak.speed.value,
        steps={1, 5},
        notifier = function(speed)
          ReSpeak.speed.value = speed
        end
      },
    },
    vb:space{height=10},
    vb:horizontal_aligner{
      mode="center",
      vb:button{
        text="Generate sample",
        width=200,
        height=24,
        notifier=function()
          ReSpeak.text.value=string.gsub(vb.views.text.text, "\n", " ")
          draw()
        end
      },
    },
  },
}

page2 = vb:column{
  id="page2",
  margin = renoise.ViewBuilder.DEFAULT_CONTROL_MARGIN,
  spacing = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING,
  height = renoise.ViewBuilder.DEFAULT_CONTROL_HEIGHT,
  width=235,
  vb:column{
    id="opt_column",
    margin = renoise.ViewBuilder.DEFAULT_CONTROL_MARGIN,
    spacing = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING,
    height = renoise.ViewBuilder.DEFAULT_CONTROL_HEIGHT,
    style="group",
    width=230,
    vb:space{height=5},
    vb:horizontal_aligner{
      mode="center",
      vb:text{text="Select executable"},
    },
    vb:horizontal_aligner{
      mode="center",
      vb:button{
        id="exe_button",
        width=200,
        height=24,
        text="Selected > info in tooltip",
        tooltip=string.format("%s", revert_path(ReSpeak.executable.value)),
        notifier=function()
          local filename = renoise.app():prompt_for_filename_to_read({"*.*"}, "Select Espeak executable")
          if filename ~= "" then
            vb.views.exe_button.tooltip = string.format("%s", filename)
            vb.views.exe_button.text = "Selected > info in tooltip"
            ReSpeak.executable.value = convert_path(filename)
          end
        end
      },
    },
    vb:space{height=20},
    vb:horizontal_aligner{
      mode="center",
      vb:button{
        width=200,
        height=24,
        text="Load settings",
        notifier=function()
          local filename = renoise.app():prompt_for_filename_to_read({"*.rts"}, "Load ReSpeak Settings")
          if filename ~= "" then
            local result = ReSpeak:load_from(filename)
            if result == nil then
              renoise.app():show_error("Can't load settings !!!")
            else
              vb.views.text:clear()
              vb.views.text:scroll_to_first_line()
              vb.views.text.text = ReSpeak.text.value
              vb.views.language.value = ReSpeak.language.value
              vb.views.voice.value = ReSpeak.voice.value
              vb.views.gap_box.value = ReSpeak.word_gap.value
              vb.views.kapitals_box.value = ReSpeak.kapitals.value
              vb.views.pitch_box.value = ReSpeak.pitch.value
              vb.views.amplitude_box.value = ReSpeak.amplitude.value
              vb.views.speed_box.value = ReSpeak.speed.value
              vb.views.exe_button.tooltip = revert_path(ReSpeak.executable.value)
              vb.views.exe_button.text = "Selected > info in tooltip"
              vb.views.clear_all_samples = ReSpeak.clear_all_samples.value
              vb.views.page1.visible=true
              vb.views.page2.visible=false
              vb.views.switcher.value=1
            end
          end
        end
      },
    },
    vb:space{height=10},
    vb:horizontal_aligner{
      mode="center",
      vb:button{
        width=200,
        height=24,
        text="Save settings",
        notifier=function()
          local filename = renoise.app():prompt_for_filename_to_write(".rts", "Save ReSpeak Settings")
          if filename ~= "" then
            ReSpeak.text.value=string.gsub(vb.views.text.text, "\n", " ")
            local result = ReSpeak:save_as(filename)
            if result == nil then
              renoise.app():show_error("Can't save settings !!!")
            end
            vb.views.page1.visible=true
            vb.views.page2.visible=false
            vb.views.switcher.value=1
          end
        end
      },
    },
    vb:space{height=5},
    vb:horizontal_aligner{
      mode="center",
      vb:row{
        vb:checkbox{
          id="clear_all_samples",
          width=18,
          height=18,
          value=ReSpeak.clear_all_samples.value,
          notifier=function(bool)
            ReSpeak.clear_all_samples.value=bool
          end
        },
        vb:text{text="Clear all instrument samples ?"},
      },
    },
  },
}


make_gui = vb:column{
  vb:space{height=5},
  vb:horizontal_aligner{
    mode="center",
    vb:switch{
      id="switcher",
      width=200,
      height=24,
      items={"Talk", "Options"},
      value=1,
      notifier=function(page)
        if page == 1 then
          vb.views.page1.visible=true
          vb.views.page2.visible=false
        elseif page == 2 then
          vb.views.page1.visible=false
          vb.views.page2.visible=true
        end
      end
    },
  },
  page1,
  page2,
}

function prepare_for_start()
  
  if (dialog and dialog.visible) then
    dialog:show()
    return
  end

  vb.views.page2.visible=false
  vb.views.exe_button.text=revert_path(ReSpeak.executable.value)
  vb.views.clear_all_samples.value=ReSpeak.clear_all_samples.value
  vb.views.switcher.value=1
  
  show_gui()
end

local function ReSpeakTTSKeyHandlerFunc(dialog, key)
  if key.modifiers=="" and key.name=="exclamation" then
    print("Exclamation key pressed, closing dialog.")
    dialog:close()
  else
    return key
  end
end

function show_gui()
  dialog=renoise.app():show_custom_dialog(
    "ReSpeak TTS v"..VERSION,
    make_gui,
    ReSpeakTTSKeyHandlerFunc)
end

function draw()
  local executable=revert_path(ReSpeak.executable.value)
  local path=os.tmpname()..".wav"

  local cmd=executable
  cmd=cmd.." -a "..ReSpeak.amplitude.value
  cmd=cmd.." -v "..LANGUAGE_SHORTS[ReSpeak.language.value]
  
  if ReSpeak.voice.value~=1 then
    cmd=cmd.."+"..VOICES[ReSpeak.voice.value]
  end

  cmd=cmd.." -b 1 -m "
  cmd=cmd.." -p "..ReSpeak.pitch.value
  cmd=cmd.." -s "..ReSpeak.speed.value
  cmd=cmd.." -g "..ReSpeak.word_gap.value
  cmd=cmd.." -k "..ReSpeak.kapitals.value
  cmd=cmd.." -w "..path
  cmd=cmd..' "'..ReSpeak.text.value..'"'

  os.execute(cmd)

  local instrument=renoise.song().selected_instrument
  instrument.name="ReSpeak TTS Instrument"

  if ReSpeak.clear_all_samples.value then
    while table.getn(instrument.samples)>0 do
      instrument:delete_sample_at(1)
    end
  end

  local sample=instrument:insert_sample_at(1)
  local buffer=sample.sample_buffer

  print("Loading path: "..path)
  if not file_exists(path) then
    renoise.app():show_error("Wave not rendered.\nThis lang is not supported\nor check your Executable.")
    return
  end
  
  local bool, result=buffer:load_from(path)
  local currentActiveMiddleFrame = renoise.app().window.active_middle_frame
  renoise.app().window.active_middle_frame = 5
end
